#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "dodajprzed.h"
#include "dodajza.h"
#include "usun.h"
#include "kryterium.h"
#include "drukujelement.h"
#include "lista.h"

int main(int argc, char*argv[])
{
	FILE *in, *out;
	struct LISTA lista;
	char c;
	char bufor[32];

	lista.n=0;
	lista.akt=0;

	in=0;
	if (argc>1) in=fopen(argv[1],"r");
	if (in)
	{
		while (fgets(bufor, 33, in))
		{
			int i;
			struct ELEMENT*tmp;
			struct ELEMENT*nowyel = new ELEMENT;
	
			strcpy(nowyel->nazwisko,bufor);
			for(i=0; nowyel->nazwisko[i]!='\n'; i++);
			nowyel->nazwisko[i]=0;
			fgets(bufor, 33, in);
			sscanf(bufor,"%d",&nowyel->wiek);
		
			if (lista.n==0)
			{
				lista.n=1;
				nowyel->poz=1;
				lista.first=nowyel;
			}
			else
			{
				tmp=lista.first;
				while (tmp->poz!=lista.n) tmp=tmp->nast;
				tmp->nast=nowyel;
				lista.n++;
				nowyel->poz=lista.n;
			}
			lista.akt=lista.first;
		}
	}
	if (in)	fclose(in);

	do
	{
		drukujelement(&lista);
		printf("\nn - nastepny element\np - poprzedni element\nd - dodaj przed tym elementem\nD - dodaj za tym elementem\nu - usun ten element\nU - usun wedlug kryterium\nk - koniec\n");
	
		for(;;)
		{
			if ((scanf("%c",&c)==0) || ((c!='n') && (c!='d') && (c!='D') && (c!='k') && (c!='u') && (c!='p') && (c!='U')))
			{
				printf("Blad, sprobuj jeszcze raz:\n");
				fflush(stdin);
			}
			else break;
		}
		fflush(stdin);
		printf("\n");

		if (c=='d') dodajprzed(&lista);
		if (c=='D') dodajza(&lista);
		if (c=='u') usun(&lista);
		if (c=='U') kryterium(&lista);
		if (c=='n') if ((lista.n!=0) && (lista.n>lista.akt->poz)) lista.akt=lista.akt->nast;
		if (c=='p') if ((lista.n!=0) && (lista.akt->poz>1))
		{
			struct ELEMENT*tmp;

			tmp=lista.first;
			while (tmp->poz!=lista.akt->poz-1) tmp=tmp->nast;
			lista.akt=tmp;
		}
	}
	while(c!='k');

	out=0;
	if (argc>2) out=fopen(argv[2], "w");
	if ((out) && (lista.n>0))
	{
		lista.akt=lista.first;
		for(;;)
		{
			fputs(lista.akt->nazwisko, out);
			fputs("\n",out);
			fprintf(out, "%d\n", lista.akt->wiek);
			if (lista.akt->poz<lista.n) lista.akt=lista.akt->nast;
			else break;
		}
	}
	if (out) fclose(out);

	if (lista.n>0)
	{
		struct ELEMENT*tmp,*tmp2;
		tmp=lista.first;
		for(;;)
		{
			if (tmp->poz<lista.n)
			{
				tmp2=tmp->nast;
				delete tmp;
				tmp=tmp2;
			}
			else
			{
				delete tmp;
				break;
			}
		}
	}

	return 0;
}