#include "objectlistiterator.h"

ObjectListIterator::ObjectListIterator(const ObjectList& alist):ListIterator(alist) {}

ObjectListIterator& ObjectListIterator::operator++()
{
	advance();
	return *this;
}

ObjectListIterator& ObjectListIterator::operator++(int)
{
	advance();
	return *this;
}

Object* ObjectListIterator::Get()
{
	return ((ObjectListElement*)get())->Get();
}

void ObjectListIterator::Set(Object*newobj=0)
{
	((ObjectListElement*)get())->Set(newobj);
}

ObjectListIterator& ObjectListIterator::operator=(const ObjectList& alist)
{
	return *this=alist;
}
