#include <iostream.h>

class DString
{
 protected:
	char* sp;
	void copy(const DString&);
 public:
	DString();
	DString(const DString&);
	DString(const char*);
	~DString();
	operator const char*();
	DString& operator=(const DString&);
	DString& operator=(const char*);

	friend ostream& operator<<(ostream&, const DString&);
	friend istream& operator>>(istream&, DString&);
	DString operator+(const DString&);
	DString operator+( char*);
	
	int operator==(const DString&);
	int operator==(const char*);

	int operator!=(const char*);
	int operator!=(const DString&);

	DString& operator+=(const DString&);
	char& operator[] (int);
	char* asChars() const;
	int asInt() const;
	int empty();
	int IsEmpty() const;
	double asDouble() const;
	int getLen() const;
	DString IsString(char*) const; 
	DString GetString(int, int) const;
	DString TrimRight(int) const;			
	DString TrimLeft(int) const;			
};
