#if !defined _list
#define _list

#include "listelement.h"

class List
{
 friend class ListIterator;

 public:
 List();
 virtual ~List(){free();}
 virtual int IsEmpty() const;
 int GetSize() const {return itemsCounter;}
 void RemoveAll();
 protected:
 ListElement* head;
 ListElement* tail;
 virtual void addHead();
 virtual void deleteHead();
 virtual void addTail();
 virtual void deleteTail();
 int insertAt(int);
 int removeFrom(int);
 ListElement* get(int)const;
 ListElement* getHead() const;
 ListElement* getTail() const;
 ListElement* findNewTail() const;
 virtual ListElement* createNewElement();
 virtual void free();

 private:
 unsigned itemsCounter;
};

#endif
