#if !defined _listiterator
#define _listiterator

#include "list.h"

class ListIterator
{
 public:
 ListIterator(const List& alist);
 virtual ~ListIterator() {}
 int AtEnd() const;
 void Restart();
 int getPosition()const {return position;}
 protected:
 virtual ListElement* get();
 virtual ListIterator& advance();
 ListIterator& operator=(const ListIterator& other);
 ListIterator& operator=(const List& alist);

 private:
 ListElement* start;
 ListElement* cursor;
 int position;
};

#endif
