#include <iostream.h>

#include "objectlist.h"
#include "objectlistiterator.h"
#include "intobject.h"

int main()
{
	int out=0;
	ObjectList lista;

	cout << "			ObjectList demo 2003 by Jakub Madej\n\n";
	cout << "Utworzony zostal nowy obiekt klasy ObjectList.\n";
	for(;;)
	{
		cout << "Wybierz opcje:\n1 - AddHead\n2 - AddTail\n3 - InsertAt\n4 - RemoveFrom\n5 - wypisanie listy za pomoca iteratora\n6 - koniec\n";
		int tmp=0;
		cin >> tmp;
		cin.clear();
		cin.ignore(1024,'\n');
		if (tmp==0)
		{
			cout << "Blad!\n";
			continue;
		}
		switch (tmp)
		{
		case 1:
			cout << "Podaj wartosc jaka ma byc zainicjalizowany nowy obiekt: ";
			cin >> tmp;
			if (!cin.good())
			{
				cout << "Blad!\n";
				cin.clear();
				cin.ignore(1024,'\n');
				continue;
			}
			lista.AddHead(new IntObject(tmp));
			cout << "Gotowe!\n";
			break;
		case 2:
			cout << "Podaj wartosc jaka ma byc zainicjalizowany nowy obiekt: ";
			cin >> tmp;
			cin.ignore(1024,'\n');
			if (!cin.good())
			{
				cout << "Blad!\n";
				cin.clear();
				continue;
			}
			lista.AddTail(new IntObject(tmp));
			cout << "Gotowe!\n";
			break;
		case 3:
			cout << "Podaj wartosc jaka ma byc zainicjalizowany nowy obiekt: ";
			cin >> tmp;
			cin.ignore(1024,'\n');
			if (!cin.good())
			{
				cout << "Blad!\n";
				cin.clear();
				continue;
			}
			cout << "Podaj pozycje na ktora wstawic (1=glowa): ";
			int tmp2;
			cin >> tmp2;
			cin.ignore(1024,'\n');
			if (!cin.good())
			{
				cout << "Blad!\n";
				cin.clear();
				continue;
			}
			lista.InsertAt(tmp2,new IntObject(tmp));
			cout << "Gotowe!\n";
			break;
		case 4:
			cout << "Podaj pozycje ktora usunac (1=glowa): ";
			cin >> tmp;
			cin.ignore(1024,'\n');
			if (!cin.good())
			{
				cout << "Blad!\n";
				cin.clear();
				continue;
			}
			lista.RemoveFrom(tmp);
			cout << "Gotowe!\n";
			break;
		case 5:
			if (!lista.IsEmpty())
			{
				ObjectListIterator iterator(lista);
				for(;;)
				{
					cout << *(IntObject*)iterator.Get() << " ";
					if (iterator.AtEnd()) break;
					iterator++;
				}
			}
			cout << endl;
			break;
		case 6:
			out=1;
			break;
		default:
			cout << "Blad!\n";
		}
		if (out) break;
	}
	return 0;
}
